{-# OPTIONS_GHC -fglasgow-exts #-}

module PolyOrder where {

import List;
import Polynomial;
import Nat;
import Option;
import Util;
import Term;
import Show;
import ErrorMonad;
import Product_Type;
import RedPair;
import UsableRules;
import Eithera;
import HOL;

get_comp_times ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> a -> a;
get_comp_times (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  ti;

get_comp_plus ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> a -> a;
get_comp_plus (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  pl;

get_comp_1 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a;
get_comp_1 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) = on;

get_comp_0 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a;
get_comp_0 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) = ze;

pleftI ::
  forall a b c.
    (Eq a,
      Eq c) => a -> a -> (a -> a -> a) ->
                           (a -> a -> a) ->
                             (a -> a) ->
                               (b -> Nat -> (a, [a])) -> Term b c -> L_poly c a;
pleftI ze on pl ti mz pia (Var x) = LPoly ze [(x, on)];
pleftI ze on pl ti mz pia (Fun f ts) =
  let {
    a = pia f (size_list ts);
    (c, asa) = a;
    (LPoly d aa) =
      sum_lpolyI ze pl (LPoly c [])
        (list_sumI (LPoly ze []) (sum_lpolyI ze pl)
          (mapa (\ at ->
                  mul_lpolyI ze ti (fst at)
                    (pleftI ze on pl ti mz pia (snd at)))
            (zipa asa ts)));
  } in (case aa of {
         [] -> LPoly (mz d) [];
         ab : lista -> LPoly d (ab : lista);
       });

prightI ::
  forall a b c.
    (Eq a,
      Eq c) => a -> a -> (a -> a -> a) ->
                           (a -> a -> a) ->
                             (a -> a) ->
                               (b -> Nat -> (a, [a])) -> Term b c -> L_poly c a;
prightI ze on pl ti mz pia (Var x) = LPoly ze [(x, on)];
prightI ze on pl ti mz pia (Fun f ts) =
  let {
    a = pia f (size_list ts);
    (c, asa) = a;
    (LPoly d aa) =
      sum_lpolyI ze pl (LPoly c [])
        (list_sumI (LPoly ze []) (sum_lpolyI ze pl)
          (mapa (\ at ->
                  mul_lpolyI ze ti (fst at)
                    (prightI ze on pl ti mz pia (snd at)))
            (zipa asa ts)));
  } in LPoly (mz d) aa;

create_afI ::
  forall a b.
    (Eq a, Eq b) => a -> [((b, Nat), (a, [a]))] -> b -> Nat -> Nat -> Bool;
create_afI ze [] f n i = True;
create_afI ze (((g, m), (c, coeffs)) : rest) f n i =
  (if f == g && m == n
    then less_nat i (size_list coeffs) && not (nth coeffs i == ze)
    else create_afI ze rest f n i);

get_comp_ge ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> a -> Bool;
get_comp_ge (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  ge;

get_comp_gt ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> a -> Bool;
get_comp_gt (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  gt;

check_polo_sI ::
  forall a b c.
    (Eq a, Sshow a, Sshow b, Eq c,
      Sshow c) => Bool ->
                    a -> a -> (a -> a -> a) ->
                                (a -> a -> a) ->
                                  (a -> a) ->
                                    (a -> a -> Bool) ->
                                      (a -> a -> Bool) ->
(b -> Nat -> (a, [a])) -> (Term b c, Term b c) -> Eithera [[Char]] ();
check_polo_sI mode ze on pl ti mz ge gt pia (s, t) =
  let {
    left = pleftI ze on pl ti mz pia s;
    right = prightI ze on pl ti mz pia t;
  } in catcha (check_lpoly_sI mode ze on ge gt left right)
         (\ x ->
           errora
             (append
                (append
                  (append
                    ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                      's', 'u', 'r', 'e', ' ']
                    (sshow_term s))
                  [' ', '>', ' '])
                (sshow_term t)
               : x));

get_comp_apos ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> Bool;
get_comp_apos (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  ap;

get_comp_max0 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> a;
get_comp_max0 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  mz;

get_comp_mono ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> Bool;
get_comp_mono (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) =
  mo;

check_polo_nsI ::
  forall a b c.
    (Eq a, Sshow a, Sshow b, Eq c,
      Sshow c) => a -> a -> (a -> a -> a) ->
                              (a -> a -> a) ->
                                (a -> a) ->
                                  (a -> a -> Bool) ->
                                    (b -> Nat -> (a, [a])) ->
                                      (Term b c, Term b c) ->
Eithera [[Char]] ();
check_polo_nsI ze on pl ti mz ge pia (s, t) =
  let {
    left = pleftI ze on pl ti mz pia s;
    right = prightI ze on pl ti mz pia t;
  } in catcha (check_lpoly_nsI ze on ge left right)
         (\ x ->
           errora
             (append
                (append
                  (append
                    ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                      's', 'u', 'r', 'e', ' ']
                    (sshow_term s))
                  [' ', '>', '=', ' '])
                (sshow_term t)
               : x));

to_lpoly_inter ::
  forall a b. (Eq b) => a -> [((b, Nat), (a, [a]))] -> b -> Nat -> (a, [a]);
to_lpoly_inter on i f n =
  (case lookupa (f, n) i of {
    Nothing -> (on, replicatea n on);
    Just cas -> cas;
  });

get_comp_description ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> [Char];
get_comp_description
  (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap)))))))))) = de;

create_lpoly_repr ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> [((b, Nat), (a, [a]))] -> [[Char]];
create_lpoly_repr c i =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in append
         [append
            ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n',
              't', 'e', 'r', 'p', 'r', 'e', 't', 'r', 'a', 't', 'i', 'o', 'n',
              ' ', 'o', 'v', 'e', 'r', ' ']
            (get_comp_description c)]
         (mapa (\ (a @ (f, n)) ->
                 let {
                   t = Fun f (mapa Var
                               (fresh_strings_list ['x', '_'] one_nat [] n));
                 } in append
                        (append (append ['P', 'o', 'l', '('] (sshow_term t))
                          [')', ' ', '=', ' '])
                        (show_lpoly (get_comp_0 c) (get_comp_1 c)
                          (pleftI (get_comp_0 c) (get_comp_1 c)
                            (get_comp_plus c) (get_comp_times c)
                            (get_comp_max0 c) pia t)))
           (remdups (mapa fst i)));

check_poly_monoI ::
  forall a b.
    (Sshow a,
      Sshow b) => a -> (a -> a -> Bool) ->
                         (a -> Bool) ->
                           [((b, Nat), (a, [a]))] -> Eithera [[Char]] ();
check_poly_monoI ze ge cm =
  (\ xs ->
    catcha
      (checkAllMI
        (\ (a @ (aa, b)) ->
          let {
            (f, n) = aa;
          } in (\ (ab @ (c, cs)) ->
                 catcha
                   (bind (bind (checkB (ge c ze)
                                 [append
                                    (append
                                      (append
['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'p', 'a', 'r', 't', ' ']
(sshow c))
                                      [' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't', ' '])
                                    (sshow ze)])
                           (\ x ->
                             checkB (less_eq_nat n (size_list cs))
                               [['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ',
                                  'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                                  'i', 's', ' ', 'i', 'g', 'n', 'o', 'r', 'e',
                                  'd']]))
                     (\ x ->
                       catcha
                         (checkAllMI
                           (\ d ->
                             checkB (cm d)
                               [append
                                  (append
                                    ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i',
                                      'e', 'n', 't', ' ']
                                    (sshow d))
                                  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                    'l', 'l', 'o', 'w', 'e', 'd']])
                           cs)
                         (\ xa -> errora (snd xa))))
                   (\ x ->
                     errora
                       (append
                          (append
                            (append
                              ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                                't', 'h', ' ', 'm', 'o', 'n', 'o', 't', 'o',
                                'n', 'i', 'c', 'i', 't', 'y', ' ', 'd', 'u',
                                'e', ' ', 't', 'o', ' ', 'i', 'n', 't', 'e',
                                'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o',
                                'n', ' ', 'o', 'f', ' ']
                              (sshow f))
                            ['/'])
                          (sshow_nat n)
                         : x)))
            b)
        xs)
      (\ x -> errora (snd x)));

get_comp_wf_elem ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool,
                      (a -> a -> Bool, (Bool, ([Char], a -> Bool))))))))))
      -> a -> Bool;
get_comp_wf_elem (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, (de, ap))))))))))
  = wfe;

check_lpoly_coeffs ::
  forall a b.
    (Sshow a,
      Sshow b) => (a -> Bool) ->
                    (a -> Bool) ->
                      (a -> Bool) ->
                        [((b, Nat), (a, [a]))] -> Eithera [[Char]] ();
check_lpoly_coeffs wfe apos ch i =
  catcha
    (checkAllMI
      (\ (a @ (aa, b)) ->
        let {
          (f, n) = aa;
        } in (\ (ab @ (c, cs)) ->
               catcha
                 (bind (bind (checkB (wfe c)
                               [append
                                  (append
                                    ['c', 'o', 'n', 's', 't', 'a', 'n', 't',
                                      ' ', 'p', 'a', 'r', 't', ' ']
                                    (sshow c))
                                  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'w',
                                    'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e',
                                    'd']])
                         (\ x ->
                           checkB (apos c || anya apos (takea n cs))
                             [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                                'f', 'i', 'n', 'd', ' ', 'p', 'o', 's', 'i',
                                't', 'i', 'v', 'e', ' ', 'e', 'n', 't', 'r',
                                'y', ' ', 'w', 'h', 'i', 'c', 'h', ' ', 'i',
                                's', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e',
                                'd', ' ', 'f', 'o', 'r', ' ', 'a', 'r', 'c',
                                't', 'i', 'c', ' ', 'i', 'n', 't', 'e', 'r',
                                'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n',
                                's']]))
                   (\ x ->
                     catcha
                       (checkAllMI
                         (\ ac ->
                           checkB (ch ac && wfe ac)
                             [append
                                (append
                                  ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e',
                                    'n', 't', ' ']
                                  (sshow ac))
                                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                  'l', 'l', 'o', 'w', 'e', 'd']])
                         cs)
                       (\ xa -> errora (snd xa))))
                 (\ x ->
                   errora
                     (append
                        (append
                          (append
                            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                              't', 'h', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r',
                              'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
                              ' ']
                            (sshow f))
                          ['/'])
                        (sshow_nat n)
                       : x)))
          b)
      i)
    (\ x -> errora (snd x));

create_rule_removal_proc_comp ::
  forall a b c.
    (Eq a, Sshow a, Eq b, Sshow b, Eq c,
      Sshow c) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> (a -> Bool) ->
                         [((b, Nat), (a, [a]))] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] -> Eithera [[Char]] ();
create_rule_removal_proc_comp c cm i r rR =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in bind (check_lpoly_coeffs (get_comp_wf_elem c) (get_comp_apos c)
              (\ x -> get_comp_ge c x (get_comp_0 c)) i)
         (\ x ->
           checkRuleRemovalProc
             (check_poly_monoI (get_comp_0 c) (get_comp_ge c) cm i)
             (check_polo_sI (get_comp_mono c) (get_comp_0 c) (get_comp_1 c)
               (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
               (get_comp_ge c) (get_comp_gt c) pia)
             (check_polo_nsI (get_comp_0 c) (get_comp_1 c) (get_comp_plus c)
               (get_comp_times c) (get_comp_max0 c) (get_comp_ge c) pia)
             (append
               (append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (get_comp_description c))
               [')'])
             (create_lpoly_repr c i) r rR);

create_mono_redpair_ur_proc_comp ::
  forall a b c.
    (Eq a, Sshow a, Eq b, Sshow b, Eq c,
      Sshow c) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> (a -> Bool) ->
                         [((b, Nat), (a, [a]))] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               [(Term b c, Term b c)] ->
                                 Maybe (b -> [(Term b c, Term b c)]) ->
                                   [(Term b c, Term b c)] ->
                                     [(Term b c, Term b c)] ->
                                       Eithera [[Char]] ();
create_mono_redpair_ur_proc_comp c cm i p rP r rm rR ur =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in bind (check_lpoly_coeffs (get_comp_wf_elem c) (get_comp_apos c)
              (\ x -> get_comp_ge c x (get_comp_0 c)) i)
         (\ x ->
           checkMonoRedPairUrProc
             (check_poly_monoI (get_comp_0 c) (get_comp_ge c) cm i)
             (check_polo_sI (get_comp_mono c) (get_comp_0 c) (get_comp_1 c)
               (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
               (get_comp_ge c) (get_comp_gt c) pia)
             (check_polo_nsI (get_comp_0 c) (get_comp_1 c) (get_comp_plus c)
               (get_comp_times c) (get_comp_max0 c) (get_comp_ge c) pia)
             (append
               (append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (get_comp_description c))
               [')'])
             (create_lpoly_repr c i) p rP r rm rR ur);

create_mono_redpair_proc_comp ::
  forall a b c.
    (Eq a, Sshow a, Eq b, Sshow b, Eq c,
      Sshow c) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> (a -> Bool) ->
                         [((b, Nat), (a, [a]))] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               [(Term b c, Term b c)] ->
                                 [(Term b c, Term b c)] -> Eithera [[Char]] ();
create_mono_redpair_proc_comp c cm i p rP r rR =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in bind (check_lpoly_coeffs (get_comp_wf_elem c) (get_comp_apos c)
              (\ x -> get_comp_ge c x (get_comp_0 c)) i)
         (\ x ->
           checkMonoRedPairProc
             (check_poly_monoI (get_comp_0 c) (get_comp_ge c) cm i)
             (check_polo_sI (get_comp_mono c) (get_comp_0 c) (get_comp_1 c)
               (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
               (get_comp_ge c) (get_comp_gt c) pia)
             (check_polo_nsI (get_comp_0 c) (get_comp_1 c) (get_comp_plus c)
               (get_comp_times c) (get_comp_max0 c) (get_comp_ge c) pia)
             (append
               (append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (get_comp_description c))
               [')'])
             (create_lpoly_repr c i) p rP r rR);

create_redpair_ur_af_proc_comp ::
  forall a b c.
    (Eq a, Sshow a, Eq b, Sshow b, Eq c,
      Sshow c) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> [((b, Nat), (a, [a]))] ->
                         [(Term b c, Term b c)] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               Maybe (b -> [(Term b c, Term b c)]) ->
                                 [(Term b c, Term b c)] -> Eithera [[Char]] ();
create_redpair_ur_af_proc_comp c i p rP r rm ur =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in bind (check_lpoly_coeffs (get_comp_wf_elem c) (get_comp_apos c)
              (\ x -> get_comp_ge c x (get_comp_0 c)) i)
         (\ x ->
           checkRedPairUrAfProc
             (check_polo_sI (get_comp_mono c) (get_comp_0 c) (get_comp_1 c)
               (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
               (get_comp_ge c) (get_comp_gt c) pia)
             (check_polo_nsI (get_comp_0 c) (get_comp_1 c) (get_comp_plus c)
               (get_comp_times c) (get_comp_max0 c) (get_comp_ge c) pia)
             (append
               (append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (get_comp_description c))
               [')'])
             (create_lpoly_repr c i) p rP r rm ur
             (create_afI (get_comp_0 c) i));

create_redpair_proc_comp ::
  forall a b c.
    (Eq a, Sshow a, Eq b, Sshow b, Eq c,
      Sshow c) => (a -> Bool,
                    (a, (a, (a -> a -> a,
                              (a -> a -> a,
                                (a -> a,
                                  (a -> a -> Bool,
                                    (a -> a -> Bool,
                                      (Bool, ([Char], a -> Bool))))))))))
                    -> [((b, Nat), (a, [a]))] ->
                         [(Term b c, Term b c)] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] -> Eithera [[Char]] ();
create_redpair_proc_comp c i p rP r =
  let {
    pia = to_lpoly_inter (get_comp_1 c) i;
  } in bind (check_lpoly_coeffs (get_comp_wf_elem c) (get_comp_apos c)
              (\ x -> get_comp_ge c x (get_comp_0 c)) i)
         (\ x ->
           checkRedPairProc
             (check_polo_sI (get_comp_mono c) (get_comp_0 c) (get_comp_1 c)
               (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
               (get_comp_ge c) (get_comp_gt c) pia)
             (check_polo_nsI (get_comp_0 c) (get_comp_1 c) (get_comp_plus c)
               (get_comp_times c) (get_comp_max0 c) (get_comp_ge c) pia)
             (append
               (append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (get_comp_description c))
               [')'])
             (create_lpoly_repr c i) p rP r);

}
