{-# OPTIONS_GHC -fglasgow-exts #-}

module RootLabeling where {

import Eithera;
import List;
import SemanticLabeling;
import Show;
import Term;
import HOL;
import Util;
import Trs;
import ErrorMonad;
import Set;

rl_fun :: forall c b a. c -> b -> Eithera a b;
rl_fun uu cs = Righta cs;

rl_inter_list :: forall a b. (Eq a) => [a] -> a -> a -> b -> a;
rl_inter_list fs d g uu = (if member g fs then g else d);

rl_tt ::
  forall f l.
    (Eq f, Sshow f, Eq l,
      Sshow l) => [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                    [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                      Eithera [[Char]] ();
rl_tt r lR =
  let {
    fs = funs_trs_list r;
  } in bind (checkB (not (nulla fs))
              [['r', 'o', 'o', 't', '-', 'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g',
                 ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 's', ' ', 'a', 't',
                 ' ', 'l', 'e', 'a', 's', 't', ' ', 'o', 'n', 'e', ' ', 'f',
                 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 's', 'y', 'm', 'b',
                 'o', 'l', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 's', 'i',
                 'g', 'n', 'a', 't', 'u', 'r', 'e']])
         (\ x ->
           let {
             d = hd fs;
           } in check_sem_lab_tt
                  (check_sl_lab_trs (rl_inter_list fs d) rl_fun fs)
                  (check_sl_model_lab_trs (rl_inter_list fs d) rl_fun fs) empty
                  (rl_inter_list fs d) rl_fun r lR);

list_diff :: forall a. (Eq a) => [a] -> [a] -> [a];
list_diff xs [] = xs;
list_diff xs (y : ys) = list_diff (removeAll y xs) ys;

rl_proc ::
  forall f l.
    (Eq f, Sshow f, Eq l,
      Sshow l) => [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                    [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                      [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                        [(Term (Lab f l) [Char], Term (Lab f l) [Char])] ->
                          Eithera [[Char]] ();
rl_proc p r lP lR =
  let {
    fs = list_union (funs_trs_list r)
           (list_diff (funs_trs_list p) (defs_list p));
  } in bind (checkB (not (nulla fs))
              [['r', 'o', 'o', 't', '-', 'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g',
                 ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 's', ' ', 'a', 't',
                 ' ', 'l', 'e', 'a', 's', 't', ' ', 'o', 'n', 'e', ' ', 'f',
                 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 's', 'y', 'm', 'b',
                 'o', 'l', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 's', 'i',
                 'g', 'n', 'a', 't', 'u', 'r', 'e']])
         (\ x ->
           let {
             d = hd fs;
           } in check_sem_lab_proc
                  (check_sl_lab_trs (rl_inter_list fs d) rl_fun fs)
                  (check_sl_model_lab_trs (rl_inter_list fs d) rl_fun fs) empty
                  (rl_inter_list fs d) rl_fun p r lP lR);

}
