{-# OPTIONS_GHC -fglasgow-exts #-}

module Trs where {

import qualified Term;
import qualified List;
import qualified Show;
import qualified HOL;
import qualified Util;

data Shp a = Sharp a | Plain a;

eq_shp :: forall f. (Eq f) => Trs.Shp f -> Trs.Shp f -> Bool;
eq_shp (Trs.Plain b) (Trs.Sharp a) = False;
eq_shp (Trs.Sharp a) (Trs.Plain b) = False;
eq_shp (Trs.Plain f) (Trs.Plain f') = f == f';
eq_shp (Trs.Sharp f) (Trs.Sharp f') = f == f';

instance (Eq a) => Eq (Trs.Shp a) where {
  a == b = Trs.eq_shp a b;
};

plaina :: forall a b. Term.Term a b -> Term.Term (Trs.Shp a) b;
plaina (Term.Var x) = Term.Var x;
plaina (Term.Fun f ss) = Term.Fun (Trs.Plain f) (List.mapa Trs.plaina ss);

sharpa :: forall a b. Term.Term a b -> Term.Term (Trs.Shp a) b;
sharpa (Term.Var x) = Term.Var x;
sharpa (Term.Fun f ss) = Term.Fun (Trs.Sharp f) (List.mapa Trs.plaina ss);

showRule ::
  forall a b.
    (Show.Sshow a, Show.Sshow b) => (Term.Term a b, Term.Term a b) -> [Char];
showRule (l, r) =
  List.append (List.append (Term.sshow_term l) [' ', '-', '>', ' '])
    (Term.sshow_term r);

showRules ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] -> [[Char]];
showRules r = List.mapa Trs.showRule r;

showDPP ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] ->
                         [(Term.Term a b, Term.Term a b)] -> [[Char]];
showDPP p r =
  ['d', 'e', 'p', 'e', 'n', 'd', 'e', 'n', 'c', 'y', ' ', 'p', 'a', 'i', 'r',
    's', ':', ' ']
    : List.append (Trs.showRules p)
        ([] : ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's', 't', 'e',
                'm', ':']
                : List.append (Trs.showRules r) [[]]);

showTRS ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] -> [[Char]];
showTRS r = List.append (Trs.showRules r) [[]];

sshow_shp :: forall b. (Show.Sshow b) => Trs.Shp b -> [Char];
sshow_shp (Trs.Sharp s) = List.append (Show.sshow s) ['#'];
sshow_shp (Trs.Plain s) = Show.sshow s;

instance (Show.Sshow a) => Show.Sshow (Trs.Shp a) where {
  sshow = Trs.sshow_shp;
};

defs_list :: forall a b. (Eq a) => [(Term.Term a b, Term.Term a b)] -> [a];
defs_list [] = [];
defs_list ((Term.Fun f uu, uv) : ts) =
  let {
    fs = Trs.defs_list ts;
  } in (if List.member f fs then fs else f : fs);
defs_list ((Term.Var uw, ux) : ts) = Trs.defs_list ts;

funs_rule_list' :: forall f v. (Term.Term f v, Term.Term f v) -> [f];
funs_rule_list' r =
  List.append (Term.funs_term_list' (fst r)) (Term.funs_term_list' (snd r));

funs_trs_list :: forall f v. (Eq f) => [(Term.Term f v, Term.Term f v)] -> [f];
funs_trs_list trs = List.remdups (Util.flat_map Trs.funs_rule_list' trs);

}
