{-# OPTIONS_GHC -fglasgow-exts #-}

module UsableRules where {

import Edg;
import List;
import Term;
import ErrorMonad;
import Nat;
import Trs;
import Option;
import Show;
import Eithera;
import HOL;
import Product_Type;

matchCapRMBelow ::
  forall a b.
    (Eq a,
      Eq b) => Term a b ->
                 Maybe (a -> [(Term a b, Term a b)]) -> Term a b -> Bool;
matchCapRMBelow l rm (Fun f ts) = gcMatchI (HFun f (mapa (capRM rm) ts)) l;

checkUrClosedTRM_af ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => (a -> [(Term a b, Term a b)]) ->
                    [(Term a b, Term a b)] ->
                      (a -> Nat -> Nat -> Bool) ->
                        Term a b -> Eithera [Char] ();
checkUrClosedTRM_af uu uv uw (Var x) = returna ();
checkUrClosedTRM_af rm ur pia (Fun f ts) =
  let {
    n = size_list ts;
  } in bind (catcha
              (checkAllMI
                (\ i ->
                  (if pia f n i then checkUrClosedTRM_af rm ur pia (nth ts i)
                    else returna ()))
                (upt Zero_nat n))
              (\ x -> errora (snd x)))
         (\ x ->
           catcha
             (checkAllMI
               (\ lr ->
                 checkB
                   (member lr ur ||
                     not (matchCapRMBelow (fst lr) (Just rm) (Fun f ts)))
                   (append
                     (append
                       (append
                         (append
                           ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e',
                             ' ', 's', 'u', 'b', 't', 'e', 'r', 'm', ' ']
                           (sshow_term (Fun f ts)))
                         [' ', 'o', 'f', ' ', 's', 'o', 'm', 'e', ' ', 'u', 's',
                           'a', 'b', 'l', 'e', ' ', 'r', 'h', 's', ',', ' ',
                           'r', 'u', 'l', 'e', ' '])
                       (showRule lr))
                     [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e', ' ',
                       'u', 's', 'a', 'b', 'l', 'e', '.']))
               (rm f))
             (\ xa -> errora (snd xa)));

checkUrClosedTRM ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => (a -> [(Term a b, Term a b)]) ->
                    [(Term a b, Term a b)] -> Term a b -> Eithera [Char] ();
checkUrClosedTRM uu uv (Var x) = returna ();
checkUrClosedTRM rm ur (Fun f ts) =
  bind (catcha (checkAllMI (checkUrClosedTRM rm ur) ts) (\ x -> errora (snd x)))
    (\ x ->
      catcha
        (checkAllMI
          (\ lr ->
            checkB
              (member lr ur ||
                not (matchCapRMBelow (fst lr) (Just rm) (Fun f ts)))
              (append
                (append
                  (append
                    (append
                      ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e', ' ',
                        's', 'u', 'b', 't', 'e', 'r', 'm', ' ']
                      (sshow_term (Fun f ts)))
                    [' ', 'o', 'f', ' ', 's', 'o', 'm', 'e', ' ', 'u', 's', 'a',
                      'b', 'l', 'e', ' ', 'r', 'h', 's', ',', ' ', 'r', 'u',
                      'l', 'e', ' '])
                  (showRule lr))
                [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e', ' ', 'u',
                  's', 'a', 'b', 'l', 'e', '.']))
          (rm f))
        (\ xa -> errora (snd xa)));

matchCapBelowI ::
  forall a b.
    (Eq a, Eq b) => Term a b -> [(Term a b, Term a b)] -> Term a b -> Bool;
matchCapBelowI l r (Fun f ts) = gcMatchI (HFun f (mapa (capI r) ts)) l;

checkUrClosedT ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] -> Term a b -> Eithera [Char] ();
checkUrClosedT uu uv (Var x) = returna ();
checkUrClosedT r ur (Fun f ts) =
  bind (catcha (checkAllMI (checkUrClosedT r ur) ts) (\ x -> errora (snd x)))
    (\ x ->
      catcha
        (checkAllMI
          (\ lr ->
            checkB (member lr ur || not (matchCapBelowI (fst lr) r (Fun f ts)))
              (append
                (append
                  (append
                    (append
                      ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e', ' ',
                        's', 'u', 'b', 't', 'e', 'r', 'm', ' ']
                      (sshow_term (Fun f ts)))
                    [' ', 'o', 'f', ' ', 's', 'o', 'm', 'e', ' ', 'u', 's', 'a',
                      'b', 'l', 'e', ' ', 'r', 'h', 's', ',', ' ', 'r', 'u',
                      'l', 'e', ' '])
                  (showRule lr))
                [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e', ' ', 'u',
                  's', 'a', 'b', 'l', 'e', '.']))
          r)
        (\ xa -> errora (snd xa)));

checkUrPClosed ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkUrPClosed r ur p =
  bind (catcha
         (catcha (checkAllMI (\ lr -> checkUrClosedT r ur (snd lr)) ur)
           (\ x -> errora (snd x)))
         (\ x ->
           errora
             [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c', 'h',
                'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's', 'u', 'r',
                'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i', 'e', 's', ' ',
                'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f', ' ', 'u', 's', 'a',
                'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's'],
               x]))
    (\ x ->
      catcha
        (catcha (checkAllMI (\ st -> checkUrClosedT r ur (snd st)) p)
          (\ xa -> errora (snd xa)))
        (\ xa ->
          errora
            [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c', 'h',
               'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's', 'u', 'r',
               'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i', 'e', 's', ' ',
               'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f', ' ', 'D', 'P', 's'],
              xa]));

checkUrPClosedRM ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    Maybe (a -> [(Term a b, Term a b)]) ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkUrPClosedRM r rmo ur p =
  (case rmo of {
    Nothing -> checkUrPClosed r ur p;
    Just rm ->
      bind (catcha
             (catcha (checkAllMI (\ lr -> checkUrClosedTRM rm ur (snd lr)) ur)
               (\ x -> errora (snd x)))
             (\ x ->
               errora
                 [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                    'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                    'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                    'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                    ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                    's'],
                   x]))
        (\ x ->
          catcha
            (catcha (checkAllMI (\ st -> checkUrClosedTRM rm ur (snd st)) p)
              (\ xa -> errora (snd xa)))
            (\ xa ->
              errora
                [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                   'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                   'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                   'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                   ' ', 'D', 'P', 's'],
                  xa]));
  });

checkMonoRedPairUrProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => Eithera [[Char]] () ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                        [Char] ->
                          [[Char]] ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] ->
                                [(Term a b, Term a b)] ->
                                  Maybe (a -> [(Term a b, Term a b)]) ->
                                    [(Term a b, Term a b)] ->
                                      [(Term a b, Term a b)] ->
Eithera [[Char]] ();
checkMonoRedPairUrProc checkMono checkSS checkNSS name representation p rP r rm
  rR ur =
  let {
    a = partition (\ foo -> isValue (checkSS foo)) p;
    (sp, nSp) = a;
    aa = partition (\ foo -> isValue (checkSS foo)) ur;
    (sr, nSr) = aa;
  } in catcha
         (bind (bind (bind (bind (bind (bind
 (catcha checkMono
   (\ x ->
     errora
       (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ', 'm',
          'o', 'n', 'o', 't', 'o', 'n', 'i', 'c', 'i', 't', 'y', ' ', 'o', 'f',
          ' ', 's', 't', 'r', 'i', 'c', 't', ' ', 'o', 'r', 'd', 'e', 'r']
         : x)))
 (\ x ->
   catcha (checkUrPClosedRM r rm ur p)
     (\ xa ->
       errora
         (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ', 'c',
            'l', 'o', 's', 'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r',
            't', 'i', 'e', 's', ' ', 'o', 'f', ' ', 'u', 's', 'a', 'b', 'l',
            'e', ' ', 'r', 'u', 'l', 'e', 's']
           : xa))))
                                   (\ x ->
                                     catcha
                                       (catcha (checkAllMI checkNSS nSr)
 (\ xa -> errora (snd xa)))
                                       (\ xa ->
 errora
   (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
      'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ',
      'r', 'u', 'l', 'e', 's']
     : xa))))
                             (\ x ->
                               catcha
                                 (catcha (checkAllMI checkNSS nSp)
                                   (\ xa -> errora (snd xa)))
                                 (\ xa ->
                                   errora
                                     (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D',
'P', 's']
                                       : xa))))
                       (\ x ->
                         catcha (checkSubset rR r)
                           (\ xa ->
                             errora
                               [['p', 'r', 'o', 'b', 'l', 'e', 'm', ':', ' ',
                                  'a', 'd', 'd', 'i', 't', 'i', 'o', 'n', 'a',
                                  'l', ' ', 'r', 'u', 'l', 'e', '(', 's', ')',
                                  ' ', 't', 'o', ' ', 'T', 'R', 'S', ' ', 'a',
                                  'd', 'd', 'e', 'd']])))
                 (\ x ->
                   catcha (checkSubset nSr rR)
                     (\ xa ->
                       errora
                         (case checkSS xa of {
                           Lefta err -> err;
                           Righta ok ->
                             [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e',
                                'r', 'r', 'o', 'r'],
                               ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o',
                                 'n', 't', 'a', 'c', 't', ' ', 'o', 'n', 'e',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'C',
                                 'e', 'T', 'A', ' ', 'm', 'e', 'm', 'b', 'e',
                                 'r', 's'],
                               ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l',
                                 '-', 'i', 'n', 'f', 'o', 'r', 'm', 'a', 't',
                                 'i', 'k', '.', 'u', 'i', 'b', 'k', '.', 'a',
                                 'c', '.', 'a', 't', '/', 's', 'o', 'f', 't',
                                 'w', 'a', 'r', 'e', '/', 'c', 'e', 't', 'a'],
                               ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o',
                                 'r', 'm', 'a', 't', 'i', 'k', '.', 'u', 'i',
                                 'b', 'k', '.', 'a', 'c', '.', 'a', 't']];
                         }))))
           (\ x ->
             catcha (checkSubset nSp rP)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e', 'r',
                          'r', 'o', 'r'],
                         ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o', 'n', 't',
                           'a', 'c', 't', ' ', 'o', 'n', 'e', ' ', 'o', 'f',
                           ' ', 't', 'h', 'e', ' ', 'C', 'e', 'T', 'A', ' ',
                           'm', 'e', 'm', 'b', 'e', 'r', 's'],
                         ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l', '-', 'i',
                           'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'k', '.',
                           'u', 'i', 'b', 'k', '.', 'a', 'c', '.', 'a', 't',
                           '/', 's', 'o', 'f', 't', 'w', 'a', 'r', 'e', '/',
                           'c', 'e', 't', 'a'],
                         ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o', 'r', 'm',
                           'a', 't', 'i', 'k', '.', 'u', 'i', 'b', 'k', '.',
                           'a', 'c', '.', 'a', 't']];
                   }))))
         (\ x ->
           errora
             (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
                'l', 'y', ' ', 't', 'h', 'e', ' ', '(', 'm', 'o', 'n', 'o', 't',
                'o', 'n', 'i', 'c', ')', ' ', 'r', 'e', 'd', 'u', 'c', 't', 'i',
                'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c', 'e',
                's', 's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e',
                ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g']
               : append representation
                   ([] : ['a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l',
                           'l', 'o', 'w', 'i', 'n', 'g', ' ', 'u', 's', 'a',
                           'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']
                           : append (showRules ur) ([] : x))));

checkUrClosedT_af ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      (a -> Nat -> Nat -> Bool) ->
                        Term a b -> Eithera [Char] ();
checkUrClosedT_af uu uv uw (Var x) = returna ();
checkUrClosedT_af r ur pia (Fun f ts) =
  let {
    n = size_list ts;
  } in bind (catcha
              (checkAllMI
                (\ i ->
                  (if pia f n i then checkUrClosedT_af r ur pia (nth ts i)
                    else returna ()))
                (upt Zero_nat n))
              (\ x -> errora (snd x)))
         (\ x ->
           catcha
             (checkAllMI
               (\ lr ->
                 checkB
                   (member lr ur || not (matchCapBelowI (fst lr) r (Fun f ts)))
                   (append
                     (append
                       (append
                         (append
                           ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e',
                             ' ', 's', 'u', 'b', 't', 'e', 'r', 'm', ' ']
                           (sshow_term (Fun f ts)))
                         [' ', 'o', 'f', ' ', 's', 'o', 'm', 'e', ' ', 'u', 's',
                           'a', 'b', 'l', 'e', ' ', 'r', 'h', 's', ',', ' ',
                           'r', 'u', 'l', 'e', ' '])
                       (showRule lr))
                     [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e', ' ',
                       'u', 's', 'a', 'b', 'l', 'e', '.']))
               r)
             (\ xa -> errora (snd xa)));

checkUrPClosed_af ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        (a -> Nat -> Nat -> Bool) -> Eithera [[Char]] ();
checkUrPClosed_af r ur p pia =
  bind (catcha
         (catcha (checkAllMI (\ lr -> checkUrClosedT_af r ur pia (snd lr)) ur)
           (\ x -> errora (snd x)))
         (\ x ->
           errora
             [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c', 'h',
                'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's', 'u', 'r',
                'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i', 'e', 's', ' ',
                'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f', ' ', 'u', 's', 'a',
                'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's'],
               x]))
    (\ x ->
      catcha
        (catcha (checkAllMI (\ st -> checkUrClosedT_af r ur pia (snd st)) p)
          (\ xa -> errora (snd xa)))
        (\ xa ->
          errora
            [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c', 'h',
               'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's', 'u', 'r',
               'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i', 'e', 's', ' ',
               'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f', ' ', 'D', 'P', 's'],
              xa]));

checkUrPClosedRM_af ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    Maybe (a -> [(Term a b, Term a b)]) ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          (a -> Nat -> Nat -> Bool) -> Eithera [[Char]] ();
checkUrPClosedRM_af r rmo ur p pia =
  (case rmo of {
    Nothing -> checkUrPClosed_af r ur p pia;
    Just rm ->
      bind (catcha
             (catcha
               (checkAllMI (\ lr -> checkUrClosedTRM_af rm ur pia (snd lr)) ur)
               (\ x -> errora (snd x)))
             (\ x ->
               errora
                 [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                    'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                    'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                    'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                    ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                    's'],
                   x]))
        (\ x ->
          catcha
            (catcha
              (checkAllMI (\ st -> checkUrClosedTRM_af rm ur pia (snd st)) p)
              (\ xa -> errora (snd xa)))
            (\ xa ->
              errora
                [['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                   'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                   'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                   'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                   ' ', 'D', 'P', 's'],
                  xa]));
  });

checkRedPairUrAfProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      [Char] ->
                        [[Char]] ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] ->
                                Maybe (a -> [(Term a b, Term a b)]) ->
                                  [(Term a b, Term a b)] ->
                                    (a -> Nat -> Nat -> Bool) ->
                                      Eithera [[Char]] ();
checkRedPairUrAfProc checkSS checkNSS name representation p rP r rm ur pia =
  let {
    a = partition (\ foo -> isValue (checkSS foo)) p;
    (sp, nSp) = a;
  } in catcha
         (bind (bind (bind (catcha (checkUrPClosedRM_af r rm ur p pia)
                             (\ x ->
                               errora
                                 (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                    'i', 't', 'h', ' ', 'c', 'l', 'o', 's', 'u',
                                    'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r',
                                    't', 'i', 'e', 's', ' ', 'o', 'f', ' ', 'u',
                                    's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l',
                                    'e', 's', ' ', 'w', '.', 'r', '.', 't', '.',
                                    ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n', 't',
                                    ' ', 'f', 'i', 'l', 't', 'e', 'r']
                                   : x)))
                       (\ x ->
                         catcha
                           (catcha (checkAllMI checkNSS ur)
                             (\ xa -> errora (snd xa)))
                           (\ xa ->
                             errora
                               (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n',
                                  't', 'i', 'n', 'g', ' ', 'u', 's', 'a', 'b',
                                  'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']
                                 : xa))))
                 (\ x ->
                   catcha
                     (catcha (checkAllMI checkNSS nSp)
                       (\ xa -> errora (snd xa)))
                     (\ xa ->
                       errora
                         (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                            'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i',
                            'n', 'g', ' ', 'D', 'P', 's']
                           : xa))))
           (\ x ->
             catcha (checkSubset nSp rP)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e', 'r',
                          'r', 'o', 'r'],
                         ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o', 'n', 't',
                           'a', 'c', 't', ' ', 'o', 'n', 'e', ' ', 'o', 'f',
                           ' ', 't', 'h', 'e', ' ', 'C', 'e', 'T', 'A', ' ',
                           'm', 'e', 'm', 'b', 'e', 'r', 's'],
                         ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l', '-', 'i',
                           'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'k', '.',
                           'u', 'i', 'b', 'k', '.', 'a', 'c', '.', 'a', 't',
                           '/', 's', 'o', 'f', 't', 'w', 'a', 'r', 'e', '/',
                           'c', 'e', 't', 'a'],
                         ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o', 'r', 'm',
                           'a', 't', 'i', 'k', '.', 'u', 'i', 'b', 'k', '.',
                           'a', 'c', '.', 'a', 't']];
                   }))))
         (\ x ->
           errora
             (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
                'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u', 'c', 't',
                'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h',
                'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g']
               : append representation
                   ([] : ['a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l',
                           'l', 'o', 'w', 'i', 'n', 'g', ' ', 'u', 's', 'a',
                           'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']
                           : append (showRules ur) ([] : x))));

}
