{-# OPTIONS_GHC -fglasgow-exts #-}

module Util where {

import List;
import HOL;

anya :: forall a. (a -> Bool) -> [a] -> Bool;
anya uu [] = False;
anya p (x : xs) = p x || anya p xs;

rev_append :: forall a. [a] -> [a] -> [a];
rev_append [] ys = ys;
rev_append (x : xs) ys = rev_append xs (x : ys);

flat_map_aux :: forall a b. (a -> [b]) -> [a] -> [b] -> [b];
flat_map_aux f [] ys = rev ys;
flat_map_aux f (x : xs) ys = flat_map_aux f xs (rev_append (f x) ys);

flat_map :: forall b a. (b -> [a]) -> [b] -> [a];
flat_map f xs = flat_map_aux f xs [];

foralla :: forall a. (a -> Bool) -> [a] -> Bool;
foralla p [] = True;
foralla p (x : xs) = p x && foralla p xs;

lookupa :: forall a b. (Eq a) => a -> [(a, b)] -> Maybe b;
lookupa uu [] = Nothing;
lookupa a ((a', b) : xs) = (if a == a' then Just b else lookupa a xs);

list_union :: forall a. (Eq a) => [a] -> [a] -> [a];
list_union [] ys = ys;
list_union (x : xs) ys =
  let {
    zs = list_union xs ys;
  } in (if member x zs then zs else x : zs);

}
